/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2022, Ha Thach (tinyusb.org)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * This file is part of the TinyUSB stack.
 */

#include "tusb.h"
#include "bsp/board_api.h"
#include "messagerie.h"
#include "com_usb.h"
#include "log.h"
#include <stdio.h>

volatile bool in_transfert_cb = 0;

size_t get_console_inputs(uint8_t* buf, size_t bufsize) {
  size_t count = 0;
  while (count < bufsize) {
    int ch = board_getchar();
    if (ch <= 0) break;

    buf[count] = (uint8_t) ch;
    count++;
  }

  return count;
}

void traiter_les_messages(uint8_t idx, struct message_t message){
  // Debug
  char message_en_clair[1024];
  message_to_string(message, message_en_clair);
  log_event(message_en_clair);

  if(message.type == '>'){
    char message_en_clair[1024];
    message_to_string(message, message_en_clair);
    printf("%s\n", message_en_clair);
  }

  if(message.type == 'r'){
    // Reception de données
    set_carte_id(idx, message.id_carte);
    struct log_buffer_t * log_buffer = get_buffer(idx);
    for(int i=0; i<message.taille_donnees; i++){
      log_buffer->tampon_echange[message.adresse_registre + i] = message.donnees[i];
    }
    /*char message_en_clair[1024];
    message_to_string(message, message_en_clair);
    log_event(message_en_clair);*/
    //printf(">d:%d\n",log_buffer->tampon_echange[0]);
  }

  if(message.type == 'd'){
    struct message_t message_emis;
    char message_binaire[64];
    uint32_t taille_message;
    // Demande de données
    uint8_t idx_lecture = get_carte_idx(message.id_carte);

    if(idx_lecture == INVALID_ID){
      printf("Erreur, no idx found\n");
      return;
    }
    struct log_buffer_t * log_buffer = get_buffer(idx_lecture);
    
    message_emis.type = 'r';
    message_emis.id_carte = message.id_carte;
    message_emis.adresse_registre = message.adresse_registre;
    message_emis.taille_donnees = message.taille_donnees;
    memcpy(message_emis.donnees, &(log_buffer->tampon_echange[message.adresse_registre]), message.taille_donnees);
    
    taille_message = message_prepare_for_usb(message_emis, message_binaire);
    
    tuh_cdc_write(idx, message_binaire, taille_message);

  }

}

void cdc_app_task(void) {
  uint8_t buf[64 + 1]; // +1 for extra null character
  uint32_t const bufsize = sizeof(buf) - 1;

  uint32_t count = get_console_inputs(buf, bufsize);
  buf[count] = 0;

  // loop over all mounted interfaces
  // Envoi des données
  for (uint8_t idx = 0; idx < CFG_TUH_CDC; idx++) {
    if (tuh_cdc_mounted(idx)) {
      // console --> cdc interfaces
      if (count) {
        tuh_cdc_write(idx, buf, count);
        tuh_cdc_write_flush(idx);
      }
    }
  }
  // Analyse des données reçues lorsque la callback a été appelée
  for (uint8_t idx = 0; idx < CFG_TUH_CDC; idx++) {
    if (tuh_cdc_mounted(idx)) {
      struct message_t message;
      char chaine[1024];
      char texte_log[255];
      unsigned int position_chaine = 0, position_sous_chaine;

      com_analyse(idx);
      while(message_disponible()){
        message = get_message();
        traiter_les_messages(idx, message); 
      }

    }
  }

}

//--------------------------------------------------------------------+
// TinyUSB callbacks
//--------------------------------------------------------------------+

// Invoked when received new data
void tuh_cdc_rx_cb(uint8_t idx) {
  if(in_transfert_cb){
    printf("already processing data\n");
    return;
  }
  in_transfert_cb = 1;
  uint8_t buf[64 + 1]; // +1 for extra null character
  uint32_t const bufsize = sizeof(buf) - 1;

  // forward cdc interfaces -> console
  uint32_t count = tuh_cdc_read(idx, buf, bufsize);
  buf[count] = 0;

  com_add(idx, buf, count);
  
  in_transfert_cb = 0;
}

// Invoked when a device with CDC interface is mounted
// idx is index of cdc interface in the internal pool.
void tuh_cdc_mount_cb(uint8_t idx) {
  tuh_itf_info_t itf_info = {0};
  tuh_cdc_itf_get_info(idx, &itf_info);

  printf("CDC Interface is mounted: address = %u, itf_num = %u, idx = %u\r\n", itf_info.daddr,
         itf_info.desc.bInterfaceNumber, idx);
  com_create(idx);

#ifdef CFG_TUH_CDC_LINE_CODING_ON_ENUM
  // If CFG_TUH_CDC_LINE_CODING_ON_ENUM is defined, line coding will be set by tinyusb stack
  // while eneumerating new cdc device
  cdc_line_coding_t line_coding = {0};
  if (tuh_cdc_get_local_line_coding(idx, &line_coding)) {
    printf("  Baudrate: %" PRIu32 ", Stop Bits : %u\r\n", line_coding.bit_rate, line_coding.stop_bits);
    printf("  Parity  : %u, Data Width: %u\r\n", line_coding.parity, line_coding.data_bits);
  }
#else
  // Set Line Coding upon mounted
  cdc_line_coding_t new_line_coding = { 115200, CDC_LINE_CODING_STOP_BITS_1, CDC_LINE_CODING_PARITY_NONE, 8 };
  tuh_cdc_set_line_coding(idx, &new_line_coding, NULL, 0);
#endif
}

// Invoked when a device with CDC interface is unmounted
void tuh_cdc_umount_cb(uint8_t idx) {
  tuh_itf_info_t itf_info = {0};
  tuh_cdc_itf_get_info(idx, &itf_info);

  printf("CDC Interface is unmounted: address = %u, itf_num = %u\r\n", itf_info.daddr,
         itf_info.desc.bInterfaceNumber);

  com_destroy(idx);
}
